; pdfBarcode V1.05
; Made by ABBKlaus 1/2006-1/2008
; PB4.10 Version on 1.6.2007
; PB4.20 Version on 2.1.2008
;
; tested with the following scanners :
;
; Datalogic Gryphon M100
; Datalogic DLL5510-M
; Datalogic FireScan D131
; Symbol P302 FZY

CompilerIf Defined(PurePDF_Include,#PB_Constant)
  IncludePath #PB_Compiler_FilePath
  XIncludeFile "PurePDFBarcode_res.pb"
  IncludePath ""
CompilerEndIf

;-Constructor
;============
ProcedureDLL PDFBarcode_Init()
  
EndProcedure

;-Destructor
;===========
ProcedureDLL PDFBarcode_End()
  
EndProcedure

Procedure.f ipf_Calculate_Barwidth(barpos,w.f)
  ProcedureReturn (barpos+2)*w
EndProcedure

Procedure.s ipf_Get_Barcode_Codes(adr)
  Protected Result$,i
  
  Result$=""
  
  For i=0 To 6
    If ?print_barcode_codes0+adr+i > ?print_barcode_codes_end
      Debug "Adress out of range : print_barcode_codes("+Str(adr+i)+")"
    Else
      If PeekB(?print_barcode_codes0+adr+i)
        Result$+"1"
      Else
        Result$+"0"
      EndIf
    EndIf
  Next
  
  ProcedureReturn Result$
EndProcedure

Procedure.s ipf_Get_Barcode_Codes39(adr)
  Protected Result$,i
  
  Result$=""
  
  For i=0 To 11
    If ?print_barcode_code39+adr+i > ?print_barcode_code39_end
      Debug "Address out of range : print_barcode_code39("+Str(adr+i)+")"
      Break
    Else
      If PeekB(?print_barcode_code39+adr+i)
        Result$+"1"
      Else
        Result$+"0"
      EndIf
    EndIf
  Next
  
  ProcedureReturn Result$
EndProcedure

Procedure.s ipf_Get_Barcode_Codes128(adr)
  Protected Result$,index=10,i
  
  If adr=106*11 ; Stop code has length of 13 Characters
    index=12
  EndIf
  
  For i=0 To index
    If ?print_barcode_code128+adr+i > ?print_barcode_code128_end
      Debug "Address out of range : print_barcode_code128("+Str(adr+i)+")"
      Break
    Else
      If PeekB(?print_barcode_code128+adr+i)
        Result$+"1"
      Else
        Result$+"0"
      EndIf
    EndIf
  Next
  
  ProcedureReturn Result$
EndProcedure

Procedure ipf_Barcode_Print_Bar(x.f,y.f,h.f,w.f,code$,align.l)
  Protected first.l,last.l,i,a$
  
  If Not (align&#PRINT_NOBARS)
    For i=1 To Len(code$)
      a$=Mid(code$,i,1)
      If a$="1" And first=0
        first=i
      EndIf
      If (a$="0" Or i=Len(code$)) And first<>0
        last=i-first
        If i=Len(code$) And a$<>"0"
          last+1
        EndIf
        pdf_Rect(x+first*w,y,last*w,h, #PDF_STYLE_FILL)
        first=0
      EndIf
    Next
  EndIf
EndProcedure

Procedure ipf_Barcode_Print_Edgebar(x.f,y.f,h.f,w.f,barpos.l,edgebar.f,align.l,code.s)
  If Not (align&#PDF_NOBARS)
    If align&#PDF_TEXT_TOP
      ipf_Barcode_Print_Bar(x+barpos*w,y-edgebar,h+edgebar,w,code.s,align)
    Else
      ipf_Barcode_Print_Bar(x+barpos*w,y,h+edgebar,w,code.s,align)
    EndIf
  EndIf
EndProcedure

Procedure ipf_Barcode_Print_Text(x.f,y.f,h.f,w.f,barpos.l,offsetx.f,offsety.f,text.s,align.l)
  Protected textx.f,texty.f,fontsize.f,x2.f
  
  If Not (align & #PDF_TEXT_NOTEXT)
    x2=x+(barpos+1)*w
    fontsize=pdf_GetFontSize()*0.70
    If align&#PDF_TEXT_CENTER
      textx=x+offsetx+((x2-x)/2)-pdf_GetStringWidth(text)/2
    ElseIf align&#PDF_TEXT_RIGHT
      textx=(x2-pdf_GetStringWidth(text))+offsetx
    Else
      textx=x+offsetx
    EndIf
    
    If align&#PDF_TEXT_TOP
      texty=y-offsety
    Else
      texty=y+offsety+fontsize+h
    EndIf
    
    pdf_Text(textx,texty,text)
  EndIf
EndProcedure

Procedure.l ipf_Barcode_GetCheckDigit_EAN(barcode.s)
  ;Compute the check digit
  Protected wSum.w,res.l,i
  
  For i = 0 To Len(barcode)-1
    If (Len(barcode)%2<>1 And i&1) Or (Len(barcode)%2 And i&1<>1)
      wSum + 3 * Val(Mid(barcode,i+1,1))
    Else
      wSum + 1 * Val(Mid(barcode,i+1,1))
    EndIf
  Next
  
  res = wSum % 10
  If (res>0)
    res =10 - res
  EndIf
  ProcedureReturn res  
EndProcedure

Procedure.f ipf_Barcode_Code2of5std(x.f,y.f,barcode.s,h.f,w.f,align.l,offsetx.f,offsety.f,checkdigit.l)
  ; http://www.barcodeisland.com/2of5.phtml    
  ; Checksum is calculated the same way as EAN code
  Protected value.w,adr.l,barpos.l,text$,checkdigit$,i,j,a$
  
  text$=barcode
  
  ; Get checkdigit
  If checkdigit=#True
    checkdigit$=Str(ipf_Barcode_GetCheckDigit_EAN(barcode))
    If Not checkdigit & #PDF_HIDECHECKDIGIT
      text$+checkdigit$
    EndIf
    barcode+checkdigit$
  EndIf
  
  barpos=0
  
  ; print start character
  ipf_Barcode_Print_Bar(x+barpos*w,y,h,w,"11011010",align)
  barpos+8
  
  For i=1 To Len(barcode)
    value=Val(Mid(barcode,i,1))
    adr=value*5
    a$=""
    For j=0 To 4
      If ?print_barcode_code2of5+adr+j > ?print_barcode_code2of5_end
        Debug "Adress out of range : print_barcode_code2of5("+Str(adr+j)+")"
        Break
      Else
        If PeekB(?print_barcode_code2of5+adr+j)=0
          a$+"10" ; Narrow
        Else
          a$+"1110" ; Wide
        EndIf
      EndIf
    Next
    ipf_Barcode_Print_Bar(x+barpos*w,y,h,w,a$,align)
    barpos+Len(a$)
  Next
  
  ; print stop character
  ipf_Barcode_Print_Bar(x+barpos*w,y,h,w,"1101011",align)
  barpos+7
  
  ; Print text
  ipf_Barcode_Print_Text(x,y,h,w,barpos,offsetx,offsety,text$,align)
  
  ProcedureReturn ipf_Calculate_Barwidth(barpos,w)
EndProcedure

Procedure.f ipf_Barcode_Code2of5(x.f,y.f,barcode.s,h.f,w.f,align.l,offsetx.f,offsety.f,checkdigit.l)
  ; http://www.barcodeisland.com/int2of5.phtml
  ; Checksum is calculated the same way as EAN code
  Protected value.w,adr.l,barpos.l,adr1.l,adr2.l,i,j,a$,text$,checkdigit$
  
  ; Check length
  If checkdigit=#True
    ; Length has to be odd
    If Len(barcode)%2<>1
      ;Debug "Len<>odd adding 0"
      barcode="0"+barcode
    EndIf
    ; Get checkdigit
    text$=barcode
    checkdigit$=Str(ipf_Barcode_GetCheckDigit_EAN(barcode))
    If Not checkdigit & #PDF_HIDECHECKDIGIT
      text$+checkdigit$
    EndIf
    barcode+checkdigit$
  Else
    ; Length has to be even
    If Len(barcode)%2
      ;Debug "Len<>even adding 0"
      barcode="0"+barcode
    EndIf
    text$=barcode
  EndIf
  
  barpos=0
  
  ; print start character
  ipf_Barcode_Print_Bar(x+barpos*w,y,h,w,"1010",align)
  barpos+4
  
  For i=1 To Len(barcode) Step 2
    adr1=Val(Mid(barcode,i+0,1)) * 5
    adr2=Val(Mid(barcode,i+1,1)) * 5
    
    a$=""
    For j=0 To 4
      If ?print_barcode_code2of5+adr1+j > ?print_barcode_code2of5_end
        Debug "Adress out of range : print_barcode_code2of5("+Str(adr1)+")"
        Break
      Else
        If PeekB(?print_barcode_code2of5+adr1+j)
          a$+"11"
        Else
          a$+"1"
        EndIf
      EndIf
      
      If ?print_barcode_code2of5+adr2+j > ?print_barcode_code2of5_end
        Debug "Adress out of range : print_barcode_code2of5("+Str(adr2)+")"
        Break
      Else
        If PeekB(?print_barcode_code2of5+adr2+j)
          a$+"00"
        Else
          a$+"0"
        EndIf
      EndIf
    Next
    
    ;Debug Mid(barcode,i,2)+"="+a$
    
    ipf_Barcode_Print_Bar(x+barpos*w,y,h,w,a$,align)
    barpos+Len(a$)
  Next
  
  ; print stop character
  ipf_Barcode_Print_Bar(x+barpos*w,y,h,w,"1101",align)
  barpos+4
  
  ; Print text
  ipf_Barcode_Print_Text(x,y,h,w,barpos,offsetx,offsety,text$,align)
  
  ProcedureReturn ipf_Calculate_Barwidth(barpos,w)
EndProcedure

Procedure.s ipf_Barcode_GetCheckDigit_Code93(barcode.s,Check.l)
  Protected wSum.l,wSum1.l,wSum2.l,res.l,value.w,Count.l=1,i
  
  For i=Len(barcode) To 1 Step -1
    value=Asc(Mid(barcode,i,1))
    If value=128
      value=0
    EndIf
    
    ;wSum = Count * value
    
    wSum1 + Count * value
    
    Count+1
    If (Check=0 And Count>20) Or (Check=1 And Count>15)
      Count=1
    EndIf
  Next
  
  wSum2=wSum1%47
  
  ;Debug wSum2
  
  If wSum2=0
    wSum2=128
  EndIf
  
  ProcedureReturn Chr(wSum2)
EndProcedure

Procedure.s ipf_Barcode_Encode_Code93(barcode.s)
  Protected string.s,value.w,value1.w,value2.w,i,adr
  
  For i=1 To Len(barcode)
    value=Asc(Mid(barcode,i,1))
    adr=value*2
    If ?print_barcode_code93a+adr+1 > ?print_barcode_code93a_end
      Debug "Adress out of range : print_barcode_code93a("+Str(adr+1)+")"
    Else
      value1=PeekB(?print_barcode_code93a+adr)
      value2=PeekB(?print_barcode_code93a+adr+1)
      If value2=0
        value2=128
      EndIf
      If value1=0
        string+Chr(value2)
        ;Debug Str(i)+" "+Chr(value)+"="+Str(value2)
      Else
        string+Chr(value1)+Chr(value2)
        ;Debug Str(i)+" "+Chr(value)+"="+Str(value1)+","+Str(value2)
      EndIf
    EndIf
  Next
  
  ProcedureReturn string
EndProcedure

Procedure.s ipf_Barcode_Decode_Code93(barcode.s)
  Protected string.s,adr.l,value1.w,value2.w,value3.w,value4.w,temp$,i,j
  
  For i=1 To Len(barcode)
    value1=Asc(Mid(barcode,i,1))
    If value1=128
      value1=0
    EndIf
    If value1=43 Or value1=44 Or value1=45 Or value1=46
      i+1:value2=Asc(Mid(barcode,i,1))
    Else
      value2=value1
      value1=0
    EndIf
    
    For j=0 To 127
      adr=j*2
      If ?print_barcode_code93a+adr+1 > ?print_barcode_code93a_end
        Debug "Adress out of range : print_barcode_code93a("+Str(adr+1)+")"
        Break
      Else
        value3=PeekB(?print_barcode_code93a+adr)
        value4=PeekB(?print_barcode_code93a+adr+1)
        If (value1=value3) And (value2=value4)
          If j<32
            string+""
          Else
            string+Chr(j)
          EndIf
          Break
        EndIf
      EndIf
    Next
  Next
  
  ProcedureReturn string
EndProcedure

Procedure.f ipf_Barcode_Code93(x.f,y.f,barcode.s,h.f,w.f,align.l,offsetx.f,offsety.f)
  ; http://www.barcodeisland.com/code93.phtml
  Protected string.s,text.s,value.w,adr.l,barpos.l,x2.f,textx.f,texty.f,fontsize.f,i,j,a$
  
  string=ipf_Barcode_Encode_Code93(barcode)
  text=ipf_Barcode_Decode_Code93(string)
  string+ipf_Barcode_GetCheckDigit_Code93(string,0)
  string+ipf_Barcode_GetCheckDigit_Code93(string,1)
  
  ; send start code (*)
  a$="101011110"
  ipf_Barcode_Print_Bar(x+barpos*w,y,h,w,a$,align)
  barpos+Len(a$)
  
  For i=1 To Len(string)
    value=Asc(Mid(string,i,1))
    If value=128
      value=0
    EndIf
    
    adr=value*9
    
    a$=""
    For j=0 To 8
      If ?print_barcode_code93+adr+j > ?print_barcode_code93_end
        Debug "Address out of range : print_barcode_code93("+Str(adr+j)+")"
        Break
      Else
        If PeekB(?print_barcode_code93+adr+j)
          a$+"1"
        Else
          a$+"0"
        EndIf
      EndIf
    Next
    
    ipf_Barcode_Print_Bar(x+barpos*w,y,h,w,a$,align)
    barpos+Len(a$)
    
    ;Debug a$+" "+Str(value)
  Next
  
  ; send end code (*)
  a$="101011110"
  ipf_Barcode_Print_Bar(x+barpos*w,y,h,w,a$,align)
  barpos+Len(a$)
  
  ; send Termination Bar
  ipf_Barcode_Print_Bar(x+barpos*w,y,h,w,"1",align)
  barpos+1
  
  ; print text
  ipf_Barcode_Print_Text(x,y,h,w,barpos,offsetx,offsety,text,align)
  
  ProcedureReturn ipf_Calculate_Barwidth(barpos,w)
EndProcedure

Procedure.w ipf_Barcode_GetCheckDigit_Code39(barcode.s)
  Protected wSum1.l,wSum2.l,value.w,i
  
  For i=1 To Len(barcode)
    value=Asc(Mid(barcode,i,1))
    If value=128
      value=0
    EndIf
    wSum1 + value
  Next
  
  wSum2=wSum1%43
  
  If wSum2=0
    wSum2=128
  EndIf
  
  ProcedureReturn wSum2
EndProcedure

Procedure.f ipf_Barcode_Code39(x.f,y.f,barcode.s,h.f,w.f,align.l,offsetx.f,offsety.f,checkdigit.l)
  ; http://www.barcodeisland.com/code39.phtml
  Protected string.s,text.s,value.w,adr.l,barpos.l,x2.f,textx.f,texty.f,fontsize.f,i,a$
  
  For i=1 To Len(barcode)
    value=Asc(Mid(barcode,i,1))
    If value>=49 And value=<57 ; 1-9
      string+Chr(value-48)
      text+Chr(value)
    ElseIf value=48 ; 0
      string+Chr(128) ; workaround for PBs string limit
      text+Chr(value)
    ElseIf value>=65 And value=<90 ; A-Z
      string+Chr(value-55)
      text+Chr(value)
    ElseIf value=45 ; -
      string+Chr(36)
      text+Chr(value)
    ElseIf value=46 ; .
      string+Chr(37)
      text+Chr(value)
    ElseIf value=32 ; SPACE
      string+Chr(38)
      text+Chr(value)
    ElseIf value=36 ; $
      string+Chr(39)
      text+Chr(value)
    ElseIf value=47 ; /
      string+Chr(40)
      text+Chr(value)
    ElseIf value=43 ; +
      string+Chr(41)
      text+Chr(value)
    ElseIf value=37 ; %
      string+Chr(42)
      text+Chr(value)
    Else
      text+"0"
    EndIf
  Next
  
  If checkdigit
    value=ipf_Barcode_GetCheckDigit_Code39(string)
    string+Chr(value)
    If Not checkdigit & #PDF_HIDECHECKDIGIT
      If value>=1 And value=<9 ; 1-9
        text+Chr(48+value)
      ElseIf value=128 ; 0
        text+""
      ElseIf value>=10 And value=<35 ; A-Z
        text+Chr(55+value)
      ElseIf value=36 ; -
        text+"-"
      ElseIf value=37 ; .
        text+"."
      ElseIf value=38 ; SPACE
        text+" "
      ElseIf value=39 ; $
        text+"$"
      ElseIf value=40 ; /
        text+"/"
      ElseIf value=41 ; +
        text+"+"
      ElseIf value=42 ; %
        text+"%"
      EndIf
      ;Debug value
    EndIf
  EndIf
  
  barpos=0
  
  ; send start code (*)
  a$=ipf_Get_Barcode_Codes39(43*12)
  ipf_Barcode_Print_Bar(x+barpos*w,y,h,w,a$,align)
  barpos+Len(a$)+1
  
  For i=1 To Len(string)
    value=Asc(Mid(string,i,1))
    If value=128
      value=0
    EndIf
    
    a$=ipf_Get_Barcode_Codes39(value*12)
    Debug "code39:"+a$
    ipf_Barcode_Print_Bar(x+barpos*w,y,h,w,a$,align)
    barpos+Len(a$)+1
    
    ;Debug a$+" "+Str(value)
  Next
  
  ; send end code (*)
  a$=ipf_Get_Barcode_Codes39(43*12)
  ipf_Barcode_Print_Bar(x+barpos*w,y,h,w,a$,align)
  barpos+Len(a$)+1
  
  ; print text
  ipf_Barcode_Print_Text(x,y,h,w,barpos,offsetx,offsety,text,align)
  
  ProcedureReturn ipf_Calculate_Barwidth(barpos,w)
EndProcedure

Procedure.f ipf_Barcode_Code39Full(x.f,y.f,barcode.s,h.f,w.f,align.l,offsetx.f,offsety.f,checkdigit.l)
  ; http://www.barcodeisland.com/code39.phtml
  Protected string.s,text.s,value.w,adr.l,barpos.l,x2.f,textx.f,texty.f,fontsize.f,i,a$
  
  For i=1 To Len(barcode)
    value=Asc(Mid(barcode,i,1))
    If value>=49 And value=<57 ; 1-9
      string+Chr(value-48)
      text+Chr(value)
    ElseIf value=48 ; (0)
      string+Chr(128) ; workaround for PBs string limit
      text+"0"
    ElseIf value>=65 And value=<90 ; A-Z
      string+Chr(value-55)
      text+Chr(value)
    ElseIf value=45 ; (-)
      string+Chr(36)
      text+"-"
    ElseIf value=46 ; (.)
      string+Chr(37)
      text+"."
    ElseIf value=32 ; SPACE
      string+Chr(38)
      text+" "
    ElseIf value=128 ; NUL
      string+Chr(42)+Chr(30)
      text+""
    ElseIf value>=1 And value=<26 ; SOH-SUB
      string+Chr(39)+Chr(value+9)
      text+""
    ElseIf value>=27 And value=<31 ; ESC-YS
      string+Chr(42)+Chr(value-17)
      text+""
    ElseIf value>=33 And value=<44 ; !"#$%&'()*+,
      string+Chr(40)+Chr(value-23)
      text+Chr(value)
      ;Debug Chr(value)
    ElseIf value=47 ; (/)
      string+Chr(40)+Chr(24)
      text+"/"
    ElseIf value=58 ; (:)
      string+Chr(40)+Chr(35)
      text+":"
    ElseIf value>=59 And value=<63 ; ;<=>?
      string+Chr(42)+Chr(value-44)
      text+Chr(value)
    ElseIf value=64 ; (@)
      string+Chr(42)+Chr(31)
      text+"@"
    ElseIf value>=91 And value=<95 ; [\]^_
      string+Chr(42)+Chr(value-71)
      text+Chr(value)
    ElseIf value=96 ; (`)
      string+Chr(42)+Chr(32)
      text+"`"
    ElseIf value>=97 And value=<122 ; a-z
      string+Chr(41)+Chr(value-87)
      text+Chr(value)
    ElseIf value>=123 And value=<126 ; {|}~
      string+Chr(42)+Chr(value-98)
      text+Chr(value)
    ElseIf value=129 ; DEL
      string+Chr(42)+Chr(29) ; or 33 or 34 or 35
      text+""
    Else
      text+"0"
    EndIf
  Next
  
  If checkdigit
    value=ipf_Barcode_GetCheckDigit_Code39(string)
    string+Chr(value)
    If Not checkdigit & #PDF_HIDECHECKDIGIT
      If value>=1 And value=<9 ; 1-9
        text+Chr(48+value)
      ElseIf value=128 ; 0
        text+""
      ElseIf value>=10 And value=<35 ; A-Z
        text+Chr(55+value)
      ElseIf value=36 ; -
        text+"-"
      ElseIf value=37 ; .
        text+"."
      ElseIf value=38 ; SPACE
        text+" "
      ElseIf value=39 ; $
        text+"$"
      ElseIf value=40 ; /
        text+"/"
      ElseIf value=41 ; +
        text+"+"
      ElseIf value=42 ; %
        text+"%"
      EndIf
      ;Debug value
    EndIf
  EndIf
  
  barpos=0
  
  ; send start code (*)
  a$=ipf_Get_Barcode_Codes39(43*12)
  ipf_Barcode_Print_Bar(x+barpos*w,y,h,w,a$,align)
  barpos+Len(a$)+1
  
  For i=1 To Len(string)
    value=Asc(Mid(string,i,1))
    If value=128
      value=0
    EndIf
    
    adr=value*12
    a$=ipf_Get_Barcode_Codes39(adr)
    ipf_Barcode_Print_Bar(x+barpos*w,y,h,w,a$,align)
    barpos+Len(a$)+1
    
    ;Debug a$+" "+Str(value)
  Next
  
  ; send end code (*)
  a$=ipf_Get_Barcode_Codes39(43*12)
  ipf_Barcode_Print_Bar(x+barpos*w,y,h,w,a$,align)
  barpos+Len(a$)+1
  
  ; print text
  ipf_Barcode_Print_Text(x,y,h,w,barpos,offsetx,offsety,text,align)
  
  ProcedureReturn ipf_Calculate_Barwidth(barpos,w)
EndProcedure

Procedure.s ipf_Check_Number(String.s)
  Protected Result$,char$,i
  For i=1 To Len(String)
    char$=Mid(String,i,1)
    If char$>="0" And char$=<"9"
      Result$+char$
    EndIf
  Next
  ProcedureReturn Result$
EndProcedure

Procedure.s ipf_Check_Codabar(barcode.s)
  Protected temp$,i,char$
  For i=1 To Len(barcode)
    char$=UCase(Mid(barcode,i,1))
    Select char$
      Case "0","1","2","3","4","5","6","7","8","9","-","$",":","/",".","+","A","B","C","D"
        temp$+char$
      Default
        temp$+"0"
    EndSelect
  Next
  
  ProcedureReturn temp$
EndProcedure

Procedure.s ipf_Check_StartStop(barcode.s)
  Select UCase(Left(barcode,1))
    Case "A","B","C","D"
    Default
      barcode="A"+barcode ; standard start character
  EndSelect
  
  Select UCase(Right(barcode,1))
    Case "A","B","C","D"
    Default
      barcode=barcode+"A" ; standard stop character
  EndSelect
  
  ProcedureReturn barcode
EndProcedure

Procedure.s ipf_Check_ValidChar(String.s)
  Protected Result$,i,char
  
  For i=1 To Len(String)
    char=Asc(Mid(String,i,1))
    If char>=1 And char<=128
      Result$+Chr(char)
    EndIf
  Next
  ProcedureReturn Result$
EndProcedure

Procedure.w ipf_Barcode_GetCheckDigit_Code128(barcode.s)
  Protected wSum1.l,wSum2.l,res.w,value.w,i
  
  For i=1 To Len(barcode)
    value=Asc(Mid(barcode,i,1))
    If value=128
      value=0
    EndIf
    
    If i=1
      wSum1 = value
    Else
      wSum1 = (i-1) * value
    EndIf
    wSum2+wSum1
  Next
  
  res = wSum2%103
  
  ProcedureReturn res
EndProcedure

Procedure.l ipf_Barcode_TestCheckDigit_EAN(barcode.s)
  ;Test validity of check digit
  Protected wSum.w,test$,i
  
  test$=Left(barcode,Len(barcode)-1)
  
  For i = 0 To Len(test$)-1
    If (Len(test$)%2<>1 And i&1) Or (Len(test$)%2 And i&1<>1)
      wSum = wSum + 3 * Val(Mid(test$,i+1,1))
    Else
      wSum = wSum + 1 * Val(Mid(test$,i+1,1))
    EndIf
  Next
  
  If (wSum + Val(Right(barcode,1))) % 10 = 0
    ProcedureReturn #True
  Else
    ProcedureReturn #False
  EndIf
EndProcedure  

Procedure ipf_Barcode_Text_EAN(x.f,y.f,h.f,w.f,offsety.f,barpos.l,align.l,text.s)
  Protected fontsize.f,textx.f,texty.f
  
  If Not (align & #PDF_TEXT_NOTEXT)
    fontsize=pdf_GetFontSize()*0.70
    If align & #PDF_TEXT_TOP
      texty=y-(offsety)
    Else
      texty=y+offsety+fontsize+h
    EndIf
    textx=x+(barpos+1)*w+(((barpos+7)*w-barpos*w)/2-pdf_GetStringWidth(text)/2)
    pdf_Text(textx,texty,text)
  EndIf
EndProcedure

Procedure.s ipf_Barcode_GetBarcode_EAN(Type.l,index.l,barcode.s)
  Protected parity.l,adr.l
  
  If Type=#PDF_BARCODE_EAN13 Or Type=#PDF_BARCODE_UPC_A
    If index<7
      adr=(index-1)+Val(Mid(barcode,1,1))*6
      If ?print_barcode_parities+adr > ?print_barcode_parities_end
        Debug "Address out of range : print_barcode_parities("+Str(adr)+")"
        parity=0
      Else
        parity=PeekB(?print_barcode_parities+adr)
      EndIf
    Else
      parity=2
    EndIf
    adr=Val(Mid(barcode,index+1,1))*7
  ElseIf Type=#PDF_BARCODE_EAN8
    If index<5
      parity=0
    Else
      parity=2
    EndIf
    adr=Val(Mid(barcode,index,1))*7
  EndIf
  
  Select parity
    Case 1
      adr+(?print_barcode_codes1-?print_barcode_codes0)
    Case 2
      adr+(?print_barcode_codes2-?print_barcode_codes0)
  EndSelect
  
  If ?print_barcode_codes0+adr > ?print_barcode_codes_end
    Debug "Address out of range : print_barcode_codes0("+Str(adr)+")"
    adr=0
  EndIf
  
  ProcedureReturn ipf_Get_Barcode_Codes(adr)
EndProcedure

Procedure.f ipf_Barcode_EAN8(x.f,y.f,barcode.s,h.f,w.f,align.l,offsety.f,edgebar.f,checkdigit.l)
  ; http://www.barcodeisland.com/ean8.phtml
  Protected barpos.l,i,a$
  
  barcode=ipf_Check_Number(barcode)
  If Len(barcode)<7
    barcode=RSet(barcode,7,"0") ; Padding
  EndIf
  If Len(barcode)=7
    barcode+Str(ipf_Barcode_GetCheckDigit_EAN(barcode))
  EndIf
  If ipf_Barcode_TestCheckDigit_EAN(barcode)=#False
    Debug "Incorrect check digit"
  EndIf
  ;Debug "EAN8:"+barcode
  
  ;Draw Bars
  
  ;Left-hand guard bars
  ipf_Barcode_Print_Edgebar(x,y,h,w,barpos,edgebar,align,"101")
  barpos+3
  
  For i = 1 To Len(barcode)
    ; Center guard bars
    If i=5
      ipf_Barcode_Print_Edgebar(x,y,h,w,barpos,edgebar,align,"01010")
      barpos+5
    EndIf
    
    ;Convert digits To bars
    a$=ipf_Barcode_GetBarcode_EAN(#PDF_BARCODE_EAN8,i,barcode)
    ;print barcode
    ipf_Barcode_Print_Bar(x+barpos*w,y,h,w,a$,align)
    If i<8 Or (i=8 And checkdigit=#True)
      ipf_Barcode_Text_EAN(x,y,h,w,offsety,barpos,align,Mid(barcode,i,1))
    EndIf
    barpos+7
  Next
  
  ;Right-hand guard bars
  ipf_Barcode_Print_Edgebar(x,y,h,w,barpos,edgebar,align,"101")
  barpos+3
  
  ProcedureReturn ipf_Calculate_Barwidth(barpos,w)
EndProcedure

Procedure.f ipf_Barcode_EAN13(x.f,y.f,barcode.s,h.f,w.f,align.l,offsety.f,edgebar.f,checkdigit.l)
  ; http://www.barcodeisland.com/ean13.phtml
  Protected barpos,a$,i
  
  barcode=ipf_Check_Number(barcode)
  If Len(barcode)<12
    barcode=RSet(barcode,12,"0") ; Padding
  EndIf
  barcode=Left(barcode,12)
  barcode+Str(ipf_Barcode_GetCheckDigit_EAN(barcode))
  
  ;Draw Bars
  a$=Mid(barcode,1,1)
  ipf_Barcode_Text_EAN(x,y,h,w,offsety,-7,align,a$)
  
  ;Left-hand guard bars
  ipf_Barcode_Print_Edgebar(x,y,h,w,barpos,edgebar,align,"101")
  barpos+3
  
  For i = 1 To Len(barcode)-1
    ;Center guard bars
    If i=7
      ipf_Barcode_Print_Edgebar(x,y,h,w,barpos,edgebar,align,"01010")
      barpos+5
    EndIf
    
    ;Convert digits To bars
    a$=ipf_Barcode_GetBarcode_EAN(#PDF_BARCODE_EAN13,i,barcode)
    ;print barcode
    ipf_Barcode_Print_Bar(x+barpos*w,y,h,w,a$,align)
    If i<12 Or (i=12 And checkdigit=#True)
      ipf_Barcode_Text_EAN(x,y,h,w,offsety,barpos,align,Mid(barcode,i+1,1))
    EndIf
    barpos+7
  Next
  
  ;Right-hand guar bars
  ipf_Barcode_Print_Edgebar(x,y,h,w,barpos,edgebar,align,"101")
  barpos+3
  
  ProcedureReturn ipf_Calculate_Barwidth(barpos,w)
EndProcedure

Procedure.f ipf_Barcode_UPC_A(x.f,y.f,barcode.s,h.f,w.f,align.l,offsety.f,edgebar.f,checkdigit.l)
  ; http://www.barcodeisland.com/upca.phtml
  Protected barpos,i,a$
  
  barcode=ipf_Check_Number(barcode)
  If Len(barcode)<11
    barcode=RSet(barcode,11,"0") ; Padding
  EndIf
  barcode="0"+barcode
  If Len(barcode)=12
    barcode+Str(ipf_Barcode_GetCheckDigit_EAN(barcode))
  EndIf
  If ipf_Barcode_TestCheckDigit_EAN(barcode)=#False
    Debug "Incorrect check digit"
  EndIf
  ;Debug "UPCA:"+barcode
  
  ;Draw Bars
  a$=Mid(barcode,2,1)
  ipf_Barcode_Text_EAN(x,y,h,w,offsety,-7,align,a$)
  
  ;Left-hand guard bars
  ipf_Barcode_Print_Edgebar(x,y,h,w,barpos,edgebar,align,"101")
  barpos+3
  
  For i = 1 To Len(barcode)-1
    ;Center guard bars
    If i=7
      ipf_Barcode_Print_Edgebar(x,y,h,w,barpos,edgebar,align,"01010")
      barpos+5
    EndIf
    
    ;Convert digits To bars
    a$=ipf_Barcode_GetBarcode_EAN(#PDF_BARCODE_UPC_A,i,barcode)
    ; edgebar handling
    If i=1 Or i=12
      ipf_Barcode_Print_Edgebar(x,y,h,w,barpos,edgebar,align,a$)
    Else
      ;print barcode
      ipf_Barcode_Print_Bar(x+barpos*w,y,h,w,a$,align)
      If i<12 Or (i=12 And checkdigit=#True)
        ipf_Barcode_Text_EAN(x,y,h,w,offsety,barpos,align,Mid(barcode,i+1,1))
      EndIf
    EndIf
    barpos+7
  Next
  
  ;Right-hand guar bars
  ipf_Barcode_Print_Edgebar(x,y,h,w,barpos,edgebar,align,"101")
  barpos+3
  
  If checkdigit
    ipf_Barcode_Text_EAN(x,y,h,w,offsety,barpos,align,Mid(barcode,13,1))
  EndIf
  
  ProcedureReturn ipf_Calculate_Barwidth(barpos,w)
EndProcedure

Procedure.f ipf_Barcode_UPC_E(x.f,y.f,barcode.s,h.f,w.f,align.l,offsety.f,edgebar.f,nsys.l)
  ; http://www.barcodeisland.com/upca.phtml
  Protected last.l,tpar.l,barpos.l,upca$,check$,adr,parity$,i,a$
  
  barcode=ipf_Check_Number(barcode)
  If Len(barcode)<6
    barcode=RSet(barcode,6,"0") ; Padding
  EndIf
  If Len(barcode)>6
    barcode=Mid(barcode,2,Len(barcode)-1) ; only characters 2-7 are taken
  EndIf
  last=Val(Mid(barcode,6,1))
  If last>=0 And last=<2
    upca$=Mid(barcode,1,2)+Mid(barcode,6,1)+"0000"+Mid(barcode,3,3)
  ElseIf last=3
    upca$=Mid(barcode,1,3)+"00000"+Mid(barcode,4,2)
  ElseIf last=4
    upca$=Mid(barcode,1,4)+"00000"+Mid(barcode,5,1)
  ElseIf last>=5 And last=<9
    upca$=Mid(barcode,1,5)+"0000"+Mid(barcode,6,1)
  EndIf
  ; Get checkdigit from UPC-A code
  check$+Str(ipf_Barcode_GetCheckDigit_EAN(Str(nsys)+upca$))
  
  ;Draw Bars
  a$=Str(nsys)
  ipf_Barcode_Text_EAN(x,y,h,w,offsety,-7,align,a$)
  
  ;Left-hand guard bars
  ipf_Barcode_Print_Edgebar(x,y,h,w,barpos,edgebar,align,"101")
  barpos+3
  
  ;Get parity encoding
  adr=Val(check$)*6
  For i=0 To 5
    If ?print_barcode_upc_e+adr+i > ?print_barcode_upc_e_end
      Debug "Address out of range : print_barcode_upc_e("+Str(adr+i)+")"
      Break
    Else
      If PeekB(?print_barcode_upc_e+adr+i)
        parity$+"1"
      Else
        parity$+"0"
      EndIf
    EndIf
  Next
  
  If Len(parity$)<>6
    Debug "Parity error!"
  Else
    For i = 1 To 6
      ;Get parity of number
      If Mid(parity$,i,1)="1"
        tpar=1
      Else
        tpar=0
      EndIf
      
      ;check number system
      tpar=tpar!nsys
      
      ;Convert digits To bars
      a$=ipf_Get_Barcode_Codes((10*tpar+Val(Mid(barcode,i,1)))*7)
      
      ;print barcode
      ipf_Barcode_Print_Bar(x+barpos*w,y,h,w,a$,align)
      
      ;print text
      ipf_Barcode_Text_EAN(x,y,h,w,offsety,barpos,align,Mid(barcode,i,1))
      barpos+Len(a$)
    Next
  EndIf
  
  ;Right-hand guar bars
  ipf_Barcode_Print_Edgebar(x,y,h,w,barpos,edgebar,align,"010101")
  barpos+6
  
  ipf_Barcode_Text_EAN(x,y,h,w,offsety,barpos,align,check$)
  
  ProcedureReturn ipf_Calculate_Barwidth(barpos,w)
EndProcedure

Procedure.s ipf_TranslateCode128A(barcode.s)
  ; Code A : SPACE !"#$%&'()*+,-./ 0-9 :;<=>?@ A-Z [\]^_ Control-Codes 0-31
  Protected string.s,nr.w=0,i
  
  ; ASCII  32 - 95  =  0-63 (-32)
  ; ASCII   1 - 31  = 65-95 (+64)
  ; ASCII  96 -102  = unchanged (for controlling purpose !)
  ; ASCII   0       = will be ASCII 128 (changed later in decode routine, bypassing PB limitation of strings)
  For i=1 To Len(barcode)
    nr=Asc(Mid(barcode,i,1))
    If (nr>=32 And nr=<95)
      string+Chr(nr-32)
    ElseIf (nr>=1 And nr=<31)
      string+Chr(nr+64)
    ElseIf (nr>=96 And nr=<102)
      string+Chr(nr)
    ElseIf (nr=128)
      string+Chr(nr)
    EndIf
  Next
  
  ProcedureReturn string
EndProcedure

Procedure.s ipf_TranslateCode128B(barcode.s)
  ; Code A : SPACE !"#$%&'()*+,-./ 0-9 :;<=>?@ A-Z [\]^_` a-z {|}~ DEL
  ; ASCII Code 127 () = DEL
  ; ASCII   0       = will be ASCII 128 (changed later in decode routine, bypassing PB limitation of strings)
  Protected string.s,nr.w=0,i
  
  ; ASCII  32-127  =  0-95 (-32)
  For i=1 To Len(barcode)
    nr=Asc(Mid(barcode,i,1))
    If (nr>=32 And nr=<127)
      string+Chr(nr-32)
    EndIf
  Next
  
  ProcedureReturn string
EndProcedure

Procedure.s ipf_TranslateCode128C(barcode.s)
  Protected string.s,nr.w=0,i
  
  If Len(barcode)%2<>0
    barcode="0"+barcode
  EndIf

  For i=1 To Len(barcode) Step 2
    nr=Val(Mid(barcode,i+0,1))*10 + Val(Mid(barcode,i+1,1))
    If nr=0
      nr=128
    EndIf
    string+Chr(nr)
  Next
  ProcedureReturn string
EndProcedure

Procedure.l ipf_Check_For2nr(barcode.s)
  Protected res=#True,i,a$
  
  If Len(barcode)%2
    res=#False
  Else
    For i=1 To Len(barcode)
      a$=Mid(barcode,i,1)
      If (a$<"0" Or a$>"9")
        res=#False
        Break
      EndIf
    Next
  EndIf
  
  ProcedureReturn res
EndProcedure

Procedure.l ipf_FindCodeset(barcode.s)
  Protected string.s,codeset.l,value.w
  
  value=Asc(Mid(barcode,1,1))
  If ipf_Check_For2nr(barcode)=#True
    codeset=2
  ElseIf (value>=1 And value=<31) Or (value=128)
    codeset=0
  ElseIf (value>=96 And value=<127)
    codeset=1
  ElseIf (value>=32 And value=<95)
    codeset=1
  EndIf
  
  ;Debug "ipf_FindCodeset("+barcode+")="+Str(codeset)
  ProcedureReturn codeset
EndProcedure

Procedure.l ipf_FindCodesetA(barcode.s)
  Protected string.s,codeset.l,value.w
  
  value=Asc(Mid(barcode,1,1))
  If ipf_Check_For2nr(barcode)=#True
    codeset=2
  ElseIf (value>=1 And value=<31) Or (value=128)
    codeset=0
  ElseIf (value>=96 And value=<127)
    codeset=1
  ElseIf (value>=32 And value=<95)
    codeset=0
  EndIf
  
  ProcedureReturn codeset
EndProcedure

Procedure.s ipf_SetCodeset(oldcodeset,newcodeset)
  Protected res.l
  
  If oldcodeset=0 And newcodeset=1
    res=100
  ElseIf oldcodeset=0 And newcodeset=2
    res=99
  ElseIf oldcodeset=1 And newcodeset=0
    res=101
  ElseIf oldcodeset=1 And newcodeset=2
    res=99
  ElseIf oldcodeset=2 And newcodeset=0
    res=101
  ElseIf oldcodeset=2 And newcodeset=1
    res=100
  EndIf
  
  ProcedureReturn Chr(res)
EndProcedure

Procedure.s ipf_TranslateCode128Auto(barcode.s,type.l)
  Protected codeset,string.s,nr.l,oldcodeset.l,newcodeset.l,i,a$
  
  If type=#PDF_BARCODE_CODE128_AUTOA
    codeset=ipf_findcodesetA(Mid(barcode,1,2))
  Else
    codeset=ipf_findcodeset(Mid(barcode,1,2))
  EndIf
  
  oldcodeset=codeset
  string+Chr(codeset+103) ; Start A/B/C
  
  For i=1 To Len(barcode)
    If codeset=2 And ipf_Check_For2nr(Mid(barcode,i,2))
      ; do not switch the codeset
    Else
      If type=#PDF_BARCODE_CODE128_AUTOA
        codeset=ipf_findcodesetA(Mid(barcode,i,4))
      Else
        codeset=ipf_findcodeset(Mid(barcode,i,4))
      EndIf
      
      If (Len(barcode)-i)<3
        If oldcodeset<>2 And codeset=2
          codeset=oldcodeset
        EndIf
      EndIf
    EndIf
    
    If codeset<>oldcodeset
      string+ipf_setcodeset(oldcodeset,codeset)
      oldcodeset=codeset
    EndIf
    
    Select codeset
      Case 0
        a$=Mid(barcode,i,1)
        ;Debug a$
        string+ipf_TranslateCode128A(a$)
      Case 1
        a$=Mid(barcode,i,1)
        ;Debug a$
        string+ipf_TranslateCode128B(a$)
      Case 2
        a$=Mid(barcode,i,2)
        ;Debug a$
        string+ipf_TranslateCode128C(a$)
        i+1
    EndSelect
  Next
  
  ProcedureReturn string
EndProcedure

Procedure.f ipf_Barcode_Code128(x.f,y.f,barcode.s,h.f,w.f,align.l,offsetx.f,offsety.f,type.l)
  ; http://www.idautomation.com/code128faq.html
  ; http://www.hi-tier.de/Entwicklung/Technik/barcode_Code128.html
  Protected adr.l,barpos.l,textx.f,texty.f,x2.f,codeset.l,value.w,text.s,fontsize.f,i,a$,skip
  
  barcode=ipf_Check_Validchar(barcode)
  Select type
    Case #PDF_BARCODE_CODE128_CODEA
      barcode=Chr(103)+ipf_TranslateCode128A(barcode)
    Case #PDF_BARCODE_CODE128_CODEB
      barcode=Chr(104)+ipf_TranslateCode128B(barcode)
    Case #PDF_BARCODE_CODE128_CODEC
      barcode=Chr(105)+ipf_TranslateCode128C(barcode)
    Case #PDF_BARCODE_CODE128_AUTO
      barcode=ipf_TranslateCode128Auto(barcode,type)
    Case #PDF_BARCODE_CODE128_AUTOA
      barcode=ipf_TranslateCode128Auto(barcode,type)
    Default ; #PDF_BARCODE_CODE128_CODEA
      barcode=Chr(103)+ipf_TranslateCode128A(barcode)
  EndSelect
  
  ; Print Barcode
  For i=1 To Len(barcode)
    value=Asc(Mid(barcode,i,1))
    Select value
      Case 128
        value=0
    EndSelect
    
    skip=0
    If value=99 And (codeset=0 Or codeset=1)
      codeset=2
      skip=1
    ElseIf value=100 And (codeset=0 Or codeset=2)
      codeset=1
      skip=1
    ElseIf value=101 And (codeset=1 Or codeset=2)
      codeset=0
      skip=1
    ElseIf value=103
      codeset=0
      skip=1
    ElseIf value=104
      codeset=1
      skip=1
    ElseIf value=105
      codeset=2
      skip=1
    EndIf
    
    If skip=0
      Select codeset
        Case 0
          ;Debug "Code128 A "+Str(value)
          If value>=0 And value=<63
            text+Chr(value+32)
          EndIf
        Case 1
          ;Debug "Code128 B "+Str(value)
          If value>=0 And value=<94
            text+Chr(value+32)
          EndIf
        Case 2
          ;Debug "Code128 C "+Str(value)
          If value>=0 And value=<99
            text+RSet(Str(value),2,"0")
          EndIf
      EndSelect
    Else
      If value>=103
        ;Debug "Start "+Chr(value-38)
      EndIf
    EndIf
    
    adr=value*11
    a$=ipf_Get_Barcode_Codes128(adr)
    ipf_Barcode_Print_Bar(x+barpos*w,y,h,w,a$,align)
    barpos+Len(a$)
  Next
  
  ; Send check digit
  value=ipf_Barcode_GetCheckDigit_Code128(barcode)
  adr=value*11
  a$=ipf_Get_Barcode_Codes128(adr)
  ipf_Barcode_Print_Bar(x+barpos*w,y,h,w,a$,align)
  barpos+Len(a$)
  
  ; Send stop code
  a$=ipf_Get_Barcode_Codes128(106*11)
  ipf_Barcode_Print_Bar(x+barpos*w,y,h,w,a$,align)
  barpos+Len(a$)
  
  ; Print text
  ipf_Barcode_Print_Text(x,y,h,w,barpos,offsetx,offsety,text,align)
  
  ProcedureReturn ipf_Calculate_Barwidth(barpos,w)
EndProcedure

Procedure.f ipf_Barcode_2Digit_Supp(x.f,y.f,barcode.s,h.f,w.f,align.l,offsetx.f,offsety.f)
  ;http://www.barcodeisland.com/upcext.phtml
  Protected adr1.l,adr2.l,barpos.l,checkdigit.l,i,a$
  
  If Len(barcode)<2
    barcode=RSet(barcode,5,"0")
  EndIf
  barcode=Left(barcode,2)
  barcode=ipf_Check_Number(barcode)
  
  ; Calculate check digit
  checkdigit=Val(barcode)%4
  
  barpos=0
  
  ; Print left guard bars
  ipf_Barcode_Print_Bar(x+barpos*w,y,h,w,"1011",align)
  barpos+4
  
  ; Print barcode
  For i=1 To 2
    adr1=checkdigit*2+i-1
    adr2=Val(Mid(barcode,i,1))*7 ; adress to odd bitpattern table
    If ?print_barcode_2digit_supp+adr1 > ?print_barcode_2digit_supp_end
      Debug "Adress out of range : print_barcode_2digit_supp("+Str(adr2)+")"
      adr2=0
    Else
      If PeekB(?print_barcode_2digit_supp+adr1)<>1
        adr2+(10*7) ; adress to even bitpattern table
      EndIf
    EndIf
    a$=ipf_Get_Barcode_Codes(adr2)
    ipf_Barcode_Print_Bar(x+barpos*w,y,h,w,a$,align)
    barpos+Len(a$)
    
    If i=1
      ipf_Barcode_Print_Bar(x+barpos*w,y,h,w,"01",align)
      barpos+2
    EndIf
  Next
  
  ; Print text
  ipf_Barcode_Print_Text(x,y,h,w,barpos,offsetx,offsety,barcode,align)
  
  ProcedureReturn ipf_Calculate_Barwidth(barpos,w)
EndProcedure

Procedure.f ipf_Barcode_5Digit_Supp(x.f,y.f,barcode.s,h.f,w.f,align.l,offsetx.f,offsety.f)
  ;http://www.barcodeisland.com/upcext.phtml
  Protected wSum.l,value.w,adr1.l,adr2.l,barpos.l,checkdigit.l,i,a$
  
  If Len(barcode)<5
    barcode=RSet(barcode,5,"0")
  EndIf
  barcode=Left(barcode,5)
  barcode=ipf_Check_Number(barcode)
  
  ; Calculate check digit
  For i=1 To Len(barcode)
    value=Val(Mid(barcode,i,1))
    If i&1
      wSum+3*value
    Else
      wSum+9*value
    EndIf
  Next
  checkdigit=Val(Right(Str(wSum),1))
  
  ; Print left guard bars
  ipf_Barcode_Print_Bar(x+barpos*w,y,h,w,"1011",align)
  barpos+4
  
  ; Print barcode
  For i=1 To 5
    adr1=checkdigit*5+i-1
    adr2=Val(Mid(barcode,i,1))*7 ; adress to odd bitpattern table
    If ?print_barcode_5digit_supp+adr1 > ?print_barcode_5digit_supp_end
      Debug "Adress out of range : print_barcode_5digit_supp("+Str(adr1)+")"
      adr1=0
    Else
      If PeekB(?print_barcode_5digit_supp+adr1)<>1
        adr2+70 ; adress to even bitpattern table
      EndIf
    EndIf
    a$=ipf_Get_Barcode_Codes(adr2)
    ipf_Barcode_Print_Bar(x+barpos*w,y,h,w,a$,align)
    barpos+Len(a$)
    
    If i<5
      ipf_Barcode_Print_Bar(x+barpos*w,y,h,w,"01",align)
      barpos+2
    EndIf
  Next
  
  ; Print text
  ipf_Barcode_Print_Text(x,y,h,w,barpos,offsetx,offsety,barcode,align)
  
  ProcedureReturn ipf_Calculate_Barwidth(barpos,w)
EndProcedure

Procedure.s ipf_Decode_Codabar(string.s)
  ; Decode width encoding table
  Protected char.w,adr.l,text$,i,bit$
  
  char=Asc(string)
  
  If char>=48 And char=<57 ; (0-9)
    adr=char-48
  ElseIf char=45 ; (-)
    adr=10
  ElseIf char=36 ; ($)
    adr=11
  ElseIf char=58 ; (:)
    adr=12
  ElseIf char=47 ; (/)
    adr=13
  ElseIf char=46 ; (.)
    adr=14
  ElseIf char=43 ; (+)
    adr=15
  ElseIf char=65 ; (A)
    adr=16
  ElseIf char=66 ; (B)
    adr=17
  ElseIf char=67 ; (C)
    adr=18
  ElseIf char=68 ; (D)
    adr=19
  Else
    adr=0
  EndIf
  
  adr*7
  If ?print_barcode_codabar+adr > ?print_barcode_codabar_end
    Debug "Adress out of range : print_barcode_codabar("+Str(adr)+")"
  Else
    For i=0 To 6
      If i&1
        bit$="0"
      Else
        bit$="1"
      EndIf
      
      If PeekB(?print_barcode_codabar+adr+i)=1
        text$+bit$+bit$
      Else
        text$+bit$
      EndIf
    Next
  EndIf
  
  Debug string+"="+text$
  
  ProcedureReturn text$
EndProcedure

Procedure.f ipf_Barcode_Codabar(x.f,y.f,barcode.s,h.f,w.f,align.l,offsetx.f,offsety.f)
  ; http://www.barcodeisland.com/codabar.phtml
  Protected barpos.l,start$,stop$,a$,i
  
  ; Check for valid chars
  barcode=ipf_Check_Codabar(barcode)
  
  ; Check for start/stop character
  barcode=ipf_Check_StartStop(barcode)
  
  ; Extract start/stop character
  start$=Left(barcode,1)
  stop$=Right(barcode,1)
  
  ; Exclude start/stop characters from text
  barcode=Mid(barcode,2,Len(barcode)-2)
  
  ; Print start character
  a$=ipf_Decode_Codabar(start$)
  ipf_Barcode_Print_Bar(x+barpos*w,y,h,w,a$,align)
  barpos+Len(a$)
  
  ; Print intercharacter space
  ipf_Barcode_Print_Bar(x+barpos*w,y,h,w,"0",align)
  barpos+1
  
  For i=1 To Len(barcode)
    ; Print barcode
    a$=ipf_Decode_Codabar(Mid(barcode,i,1))
    ipf_Barcode_Print_Bar(x+barpos*w,y,h,w,a$,align)
    barpos+Len(a$)
    
    ; Print intercharacter space
    ipf_Barcode_Print_Bar(x+barpos*w,y,h,w,"0",align)
    barpos+1
  Next
  
  ; Print stop character
  a$=ipf_Decode_Codabar(stop$)
  ipf_Barcode_Print_Bar(x+barpos*w,y,h,w,a$,align)
  barpos+Len(a$)
  
  ; Print text
  ipf_Barcode_Print_Text(x,y,h,w,barpos,offsetx,offsety,barcode,align)
  
  ProcedureReturn ipf_Calculate_Barwidth(barpos,w)
EndProcedure

DataSection
  print_barcode_parities:
  Data.b 0,0,0,0,0,0 ; 0
  Data.b 0,0,1,0,1,1 ; 1
  Data.b 0,0,1,1,0,1 ; 2
  Data.b 0,0,1,1,1,0 ; 3
  Data.b 0,1,0,0,1,1 ; 4
  Data.b 0,1,1,0,0,1 ; 5
  Data.b 0,1,1,1,0,0 ; 6
  Data.b 0,1,0,1,0,1 ; 7
  Data.b 0,1,0,1,1,0 ; 8
  Data.b 0,1,1,0,1,0 ; 9
  print_barcode_parities_end:
  
  print_barcode_codes0:
  Data.b 0,0,0,1,1,0,1 ; 0,0 left hand odd parity
  Data.b 0,0,1,1,0,0,1 ; 0,1
  Data.b 0,0,1,0,0,1,1 ; 0,2
  Data.b 0,1,1,1,1,0,1 ; 0,3
  Data.b 0,1,0,0,0,1,1 ; 0,4
  Data.b 0,1,1,0,0,0,1 ; 0,5
  Data.b 0,1,0,1,1,1,1 ; 0,6
  Data.b 0,1,1,1,0,1,1 ; 0,7
  Data.b 0,1,1,0,1,1,1 ; 0,8
  Data.b 0,0,0,1,0,1,1 ; 0,9
  print_barcode_codes1:
  Data.b 0,1,0,0,1,1,1 ; 1,0 left hand even parity
  Data.b 0,1,1,0,0,1,1 ; 1,1
  Data.b 0,0,1,1,0,1,1 ; 1,2
  Data.b 0,1,0,0,0,0,1 ; 1,3
  Data.b 0,0,1,1,1,0,1 ; 1,4
  Data.b 0,1,1,1,0,0,1 ; 1,5
  Data.b 0,0,0,0,1,0,1 ; 1,6
  Data.b 0,0,1,0,0,0,1 ; 1,7
  Data.b 0,0,0,1,0,0,1 ; 1,8
  Data.b 0,0,1,0,1,1,1 ; 1,9
  print_barcode_codes2:
  Data.b 1,1,1,0,0,1,0 ; 2,0 ?
  Data.b 1,1,0,0,1,1,0 ; 2,1
  Data.b 1,1,0,1,1,0,0 ; 2,2
  Data.b 1,0,0,0,0,1,0 ; 2,3
  Data.b 1,0,1,1,1,0,0 ; 2,4
  Data.b 1,0,0,1,1,1,0 ; 2,5
  Data.b 1,0,1,0,0,0,0 ; 2,6
  Data.b 1,0,0,0,1,0,0 ; 2,7
  Data.b 1,0,0,1,0,0,0 ; 2,8
  Data.b 1,1,1,0,1,0,0 ; 2,9
  print_barcode_codes_end:
  
  print_barcode_upc_e:
  Data.b 1,1,1,0,0,0 ; 0 EEEOOO
  Data.b 1,1,0,1,0,0 ; 1 EEOEOO
  Data.b 1,1,0,0,1,0 ; 2 EEOOEO
  Data.b 1,1,0,0,0,1 ; 3 EEOOOE
  Data.b 1,0,1,1,0,0 ; 4 EOEEOO
  Data.b 1,0,0,1,1,0 ; 5 EOOEEO
  Data.b 1,0,0,0,1,1 ; 6 EOOOEE
  Data.b 1,0,1,0,1,0 ; 7 EOEOEO
  Data.b 1,0,1,0,0,1 ; 8 EOEOOE
  Data.b 1,0,0,1,0,1 ; 9 EOOEOE
  print_barcode_upc_e_end:
  
  print_barcode_code128:  ; Value Code A Code B Code C
  Data.b 1,1,0,1,1,0,0,1,1,0,0 ;    0   Space  Space   00
  Data.b 1,1,0,0,1,1,0,1,1,0,0 ;    1     !      !     01
  Data.b 1,1,0,0,1,1,0,0,1,1,0 ;    2     "      "     02
  Data.b 1,0,0,1,0,0,1,1,0,0,0 ;    3     #      #     03
  Data.b 1,0,0,1,0,0,0,1,1,0,0 ;    4     $      $     04
  Data.b 1,0,0,0,1,0,0,1,1,0,0 ;    5     %      %     05
  Data.b 1,0,0,1,1,0,0,1,0,0,0 ;    6     &      &     06
  Data.b 1,0,0,1,1,0,0,0,1,0,0 ;    7     '      '     07
  Data.b 1,0,0,0,1,1,0,0,1,0,0 ;    8     (      (     08
  Data.b 1,1,0,0,1,0,0,1,0,0,0 ;    9     )      )     09
  Data.b 1,1,0,0,1,0,0,0,1,0,0 ;   10     *      *     10
  Data.b 1,1,0,0,0,1,0,0,1,0,0 ;   11     +      +     11
  Data.b 1,0,1,1,0,0,1,1,1,0,0 ;   12     ,      ,     12
  Data.b 1,0,0,1,1,0,1,1,1,0,0 ;   13     -      -     13
  Data.b 1,0,0,1,1,0,0,1,1,1,0 ;   14     .      .     14
  Data.b 1,0,1,1,1,0,0,1,1,0,0 ;   15     /      /     15
  Data.b 1,0,0,1,1,1,0,1,1,0,0 ;   16     0      0     16
  Data.b 1,0,0,1,1,1,0,0,1,1,0 ;   17     1      1     17
  Data.b 1,1,0,0,1,1,1,0,0,1,0 ;   18     2      2     18
  Data.b 1,1,0,0,1,0,1,1,1,0,0 ;   19     3      3     19
  Data.b 1,1,0,0,1,0,0,1,1,1,0 ;   20     4      4     20
  Data.b 1,1,0,1,1,1,0,0,1,0,0 ;   21     5      5     21
  Data.b 1,1,0,0,1,1,1,0,1,0,0 ;   22     6      6     22
  Data.b 1,1,1,0,1,1,0,1,1,1,0 ;   23     7      7     23
  Data.b 1,1,1,0,1,0,0,1,1,0,0 ;   24     8      8     24
  Data.b 1,1,1,0,0,1,0,1,1,0,0 ;   25     9      9     25
  Data.b 1,1,1,0,0,1,0,0,1,1,0 ;   26     :      :     26
  Data.b 1,1,1,0,1,1,0,0,1,0,0 ;   27     ;      ;     27
  Data.b 1,1,1,0,0,1,1,0,1,0,0 ;   28     <      <     28
  Data.b 1,1,1,0,0,1,1,0,0,1,0 ;   29     =      =     29
  Data.b 1,1,0,1,1,0,1,1,0,0,0 ;   30     >      >     30
  Data.b 1,1,0,1,1,0,0,0,1,1,0 ;   31     ?      ?     31
  Data.b 1,1,0,0,0,1,1,0,1,1,0 ;   32     @      @     32
  Data.b 1,0,1,0,0,0,1,1,0,0,0 ;   33     A      A     33
  Data.b 1,0,0,0,1,0,1,1,0,0,0 ;   34     B      B     34
  Data.b 1,0,0,0,1,0,0,0,1,1,0 ;   35     C      C     35
  Data.b 1,0,1,1,0,0,0,1,0,0,0 ;   36     D      D     36
  Data.b 1,0,0,0,1,1,0,1,0,0,0 ;   37     E      E     37
  Data.b 1,0,0,0,1,1,0,0,0,1,0 ;   38     F      F     38
  Data.b 1,1,0,1,0,0,0,1,0,0,0 ;   39     G      G     39
  Data.b 1,1,0,0,0,1,0,1,0,0,0 ;   40     H      H     40
  Data.b 1,1,0,0,0,1,0,0,0,1,0 ;   41     I      I     41
  Data.b 1,0,1,1,0,1,1,1,0,0,0 ;   42     J      J     42
  Data.b 1,0,1,1,0,0,0,1,1,1,0 ;   43     K      K     43
  Data.b 1,0,0,0,1,1,0,1,1,1,0 ;   44     L      L     44
  Data.b 1,0,1,1,1,0,1,1,0,0,0 ;   45     M      M     45
  Data.b 1,0,1,1,1,0,0,0,1,1,0 ;   46     N      N     46
  Data.b 1,0,0,0,1,1,1,0,1,1,0 ;   47     O      O     47
  Data.b 1,1,1,0,1,1,1,0,1,1,0 ;   48     P      P     48
  Data.b 1,1,0,1,0,0,0,1,1,1,0 ;   49     Q      Q     49
  Data.b 1,1,0,0,0,1,0,1,1,1,0 ;   50     R      R     50
  Data.b 1,1,0,1,1,1,0,1,0,0,0 ;   51     S      S     51
  Data.b 1,1,0,1,1,1,0,0,0,1,0 ;   52     T      T     52
  Data.b 1,1,0,1,1,1,0,1,1,1,0 ;   53     U      U     53
  Data.b 1,1,1,0,1,0,1,1,0,0,0 ;   54     V      V     54
  Data.b 1,1,1,0,1,0,0,0,1,1,0 ;   55     W      W     55
  Data.b 1,1,1,0,0,0,1,0,1,1,0 ;   56     X      X     56
  Data.b 1,1,1,0,1,1,0,1,0,0,0 ;   57     Y      Y     57
  Data.b 1,1,1,0,1,1,0,0,0,1,0 ;   58     Z      Z     58
  Data.b 1,1,1,0,0,0,1,1,0,1,0 ;   59     [      [     59
  Data.b 1,1,1,0,1,1,1,1,0,1,0 ;   60     \      \     60
  Data.b 1,1,0,0,1,0,0,0,0,1,0 ;   61     ]      ]     61
  Data.b 1,1,1,1,0,0,0,1,0,1,0 ;   62     ^      ^     62
  Data.b 1,0,1,0,0,1,1,0,0,0,0 ;   63     _      _     63
  Data.b 1,0,1,0,0,0,0,1,1,0,0 ;   64    nul     `     64
  Data.b 1,0,0,1,0,1,1,0,0,0,0 ;   65    soh     a     65
  Data.b 1,0,0,1,0,0,0,0,1,1,0 ;   66    stx     b     66
  Data.b 1,0,0,0,0,1,0,1,1,0,0 ;   67    etx     c     67
  Data.b 1,0,0,0,0,1,0,0,1,1,0 ;   68    eot     d     68
  Data.b 1,0,1,1,0,0,1,0,0,0,0 ;   69    eno     e     69
  Data.b 1,0,1,1,0,0,0,0,1,0,0 ;   70    ack     f     70
  Data.b 1,0,0,1,1,0,1,0,0,0,0 ;   71    bel     g     71
  Data.b 1,0,0,1,1,0,0,0,0,1,0 ;   72    bs      h     72
  Data.b 1,0,0,0,0,1,1,0,1,0,0 ;   73    ht      i     73
  Data.b 1,0,0,0,0,1,1,0,0,1,0 ;   74    lf      j     74
  Data.b 1,1,0,0,0,0,1,0,0,1,0 ;   75    vt      k     75
  Data.b 1,1,0,0,1,0,1,0,0,0,0 ;   76    ff      l     76
  Data.b 1,1,1,1,0,1,1,1,0,1,0 ;   77    cr      m     77
  Data.b 1,1,0,0,0,0,1,0,1,0,0 ;   78    s0      n     78
  Data.b 1,0,0,0,1,1,1,1,0,1,0 ;   79    s1      o     79
  Data.b 1,0,1,0,0,1,1,1,1,0,0 ;   80    dle     p     80
  Data.b 1,0,0,1,0,1,1,1,1,0,0 ;   81    dc1     q     81
  Data.b 1,0,0,1,0,0,1,1,1,1,0 ;   82    dc2     r     82
  Data.b 1,0,1,1,1,1,0,0,1,0,0 ;   83    dc3     s     83
  Data.b 1,0,0,1,1,1,1,0,1,0,0 ;   84    dc4     t     84
  Data.b 1,0,0,1,1,1,1,0,0,1,0 ;   85    nak     u     85
  Data.b 1,1,1,1,0,1,0,0,1,0,0 ;   86    syn     v     86
  Data.b 1,1,1,1,0,0,1,0,1,0,0 ;   87    etb     w     87
  Data.b 1,1,1,1,0,0,1,0,0,1,0 ;   88    can     x     88
  Data.b 1,1,0,1,1,0,1,1,1,1,0 ;   89    em      y     89
  Data.b 1,1,0,1,1,1,1,0,1,1,0 ;   90    sub     z     90
  Data.b 1,1,1,1,0,1,1,0,1,1,0 ;   91    esc     {     91
  Data.b 1,0,1,0,1,1,1,1,0,0,0 ;   92    fs      |     92
  Data.b 1,0,1,0,0,0,1,1,1,1,0 ;   93    gs      }     93
  Data.b 1,0,0,0,1,0,1,1,1,1,0 ;   94    rs      ~     94
  Data.b 1,0,1,1,1,1,0,1,0,0,0 ;   95    us     del    95
  Data.b 1,0,1,1,1,1,0,0,0,1,0 ;   96   func3  func3   96
  Data.b 1,1,1,1,0,1,0,1,0,0,0 ;   97   func2  func2   97
  Data.b 1,1,1,1,0,1,0,0,0,1,0 ;   98   shift  shift   98
  Data.b 1,0,1,1,1,0,1,1,1,1,0 ;   99   CodeC  CodeC   99
  Data.b 1,0,1,1,1,1,0,1,1,1,0 ;  100   CodeB  func4  Code B
  Data.b 1,1,1,0,1,0,1,1,1,1,0 ;  101   func4  CodeA  Code A
  Data.b 1,1,1,1,0,1,0,1,1,1,0 ;  102   func1  func1  func1
  Data.b 1,1,0,1,0,0,0,0,1,0,0 ;  103   StartA StartA Start A
  Data.b 1,1,0,1,0,0,1,0,0,0,0 ;  104   StartB StartB Start B
  Data.b 1,1,0,1,0,0,1,1,1,0,0 ;  105   StartC StartC Start C
  Data.b 1,1,0,0,0,1,1,1,0,1,0,1,1 ; 106    Stop   Stop   Stop
  print_barcode_code128_end:
  
  print_barcode_code39:   ; Check ASCII
  Data.b 1,0,1,0,0,1,1,0,1,1,0,1 ;  0      0
  Data.b 1,1,0,1,0,0,1,0,1,0,1,1 ;  1      1
  Data.b 1,0,1,1,0,0,1,0,1,0,1,1 ;  2      2
  Data.b 1,1,0,1,1,0,0,1,0,1,0,1 ;  3      3
  Data.b 1,0,1,0,0,1,1,0,1,0,1,1 ;  4      4
  Data.b 1,1,0,1,0,0,1,1,0,1,0,1 ;  5      5
  Data.b 1,0,1,1,0,0,1,1,0,1,0,1 ;  6      6
  Data.b 1,0,1,0,0,1,0,1,1,0,1,1 ;  7      7
  Data.b 1,1,0,1,0,0,1,0,1,1,0,1 ;  8      8
  Data.b 1,0,1,1,0,0,1,0,1,1,0,1 ;  9      9
  Data.b 1,1,0,1,0,1,0,0,1,0,1,1 ; 10      A
  Data.b 1,0,1,1,0,1,0,0,1,0,1,1 ; 11      B
  Data.b 1,1,0,1,1,0,1,0,0,1,0,1 ; 12      C
  Data.b 1,0,1,0,1,1,0,0,1,0,1,1 ; 13      D
  Data.b 1,1,0,1,0,1,1,0,0,1,0,1 ; 14      E
  Data.b 1,0,1,1,0,1,1,0,0,1,0,1 ; 15      F
  Data.b 1,0,1,0,1,0,0,1,1,0,1,1 ; 16      G
  Data.b 1,1,0,1,0,1,0,0,1,1,0,1 ; 17      H
  Data.b 1,0,1,1,0,1,0,0,1,1,0,1 ; 18      I
  Data.b 1,0,1,0,1,1,0,0,1,1,0,1 ; 19      J
  Data.b 1,1,0,1,0,1,0,1,0,0,1,1 ; 20      K
  Data.b 1,0,1,1,0,1,0,1,0,0,1,1 ; 21      L
  Data.b 1,1,0,1,1,0,1,0,1,0,0,1 ; 22      M
  Data.b 1,0,1,0,1,1,0,1,0,0,1,1 ; 23      N
  Data.b 1,1,0,1,0,1,1,0,1,0,0,1 ; 24      O
  Data.b 1,0,1,1,0,1,1,0,1,0,0,1 ; 25      P
  Data.b 1,0,1,0,1,0,1,1,0,0,1,1 ; 26      Q
  Data.b 1,1,0,1,0,1,0,1,1,0,0,1 ; 27      R
  Data.b 1,0,1,1,0,1,0,1,1,0,0,1 ; 28      S
  Data.b 1,0,1,0,1,1,0,1,1,0,0,1 ; 29      T
  Data.b 1,1,0,0,1,0,1,0,1,0,1,1 ; 30      U
  Data.b 1,0,0,1,1,0,1,0,1,0,1,1 ; 31      V
  Data.b 1,1,0,0,1,1,0,1,0,1,0,1 ; 32      W
  Data.b 1,0,0,1,0,1,1,0,1,0,1,1 ; 33      X
  Data.b 1,1,0,0,1,0,1,1,0,1,0,1 ; 34      Y
  Data.b 1,0,0,1,1,0,1,1,0,1,0,1 ; 35      Z
  Data.b 1,0,0,1,0,1,0,1,1,0,1,1 ; 36      -
  Data.b 1,1,0,0,1,0,1,0,1,1,0,1 ; 37      .
  Data.b 1,0,0,1,1,0,1,0,1,1,0,1 ; 38    SPACE
  Data.b 1,0,0,1,0,0,1,0,0,1,0,1 ; 39      $
  Data.b 1,0,0,1,0,0,1,0,1,0,0,1 ; 40      /
  Data.b 1,0,0,1,0,1,0,0,1,0,0,1 ; 41      +
  Data.b 1,0,1,0,0,1,0,0,1,0,0,1 ; 42      %
  Data.b 1,0,0,1,0,1,1,0,1,1,0,1 ; 43      * ; end code
  print_barcode_code39_end:
  
  print_barcode_code93: ; Value ASCII
  Data.b 1,0,0,0,1,0,1,0,0 ;    0     0
  Data.b 1,0,1,0,0,1,0,0,0 ;    1     1
  Data.b 1,0,1,0,0,0,1,0,0 ;    2     2
  Data.b 1,0,1,0,0,0,0,1,0 ;    3     3
  Data.b 1,0,0,1,0,1,0,0,0 ;    4     4
  Data.b 1,0,0,1,0,0,1,0,0 ;    5     5
  Data.b 1,0,0,1,0,0,0,1,0 ;    6     6
  Data.b 1,0,1,0,1,0,0,0,0 ;    7     7
  Data.b 1,0,0,0,1,0,0,1,0 ;    8     8
  Data.b 1,0,0,0,0,1,0,1,0 ;    9     9
  Data.b 1,1,0,1,0,1,0,0,0 ;   10     A
  Data.b 1,1,0,1,0,0,1,0,0 ;   11     B
  Data.b 1,1,0,1,0,0,0,1,0 ;   12     C
  Data.b 1,1,0,0,1,0,1,0,0 ;   13     D
  Data.b 1,1,0,0,1,0,0,1,0 ;   14     E
  Data.b 1,1,0,0,0,1,0,1,0 ;   15     F
  Data.b 1,0,1,1,0,1,0,0,0 ;   16     G
  Data.b 1,0,1,1,0,0,1,0,0 ;   17     H
  Data.b 1,0,1,1,0,0,0,1,0 ;   18     I
  Data.b 1,0,0,1,1,0,1,0,0 ;   19     J
  Data.b 1,0,0,0,1,1,0,1,0 ;   20     K
  Data.b 1,0,1,0,1,1,0,0,0 ;   21     L
  Data.b 1,0,1,0,0,1,1,0,0 ;   22     M
  Data.b 1,0,1,0,0,0,1,1,0 ;   23     N
  Data.b 1,0,0,1,0,1,1,0,0 ;   24     O
  Data.b 1,0,0,0,1,0,1,1,0 ;   25     P
  Data.b 1,1,0,1,1,0,1,0,0 ;   26     Q
  Data.b 1,1,0,1,1,0,0,1,0 ;   27     R
  Data.b 1,1,0,1,0,1,1,0,0 ;   28     S
  Data.b 1,1,0,1,0,0,1,1,0 ;   29     T
  Data.b 1,1,0,0,1,0,1,1,0 ;   30     U
  Data.b 1,1,0,0,1,1,0,1,0 ;   31     V
  Data.b 1,0,1,1,0,1,1,0,0 ;   32     W
  Data.b 1,0,1,1,0,0,1,1,0 ;   33     X
  Data.b 1,0,0,1,1,0,1,1,0 ;   34     Y
  Data.b 1,0,0,1,1,1,0,1,0 ;   35     Z
  Data.b 1,0,0,1,0,1,1,1,0 ;   36     -
  Data.b 1,1,1,0,1,0,1,0,0 ;   37     .
  Data.b 1,1,1,0,1,0,0,1,0 ;   38   SPACE
  Data.b 1,1,1,0,0,1,0,1,0 ;   39     $
  Data.b 1,0,1,1,0,1,1,1,0 ;   40     /
  Data.b 1,0,1,1,1,0,1,1,0 ;   41     +
  Data.b 1,1,0,1,0,1,1,1,0 ;   42     %
  Data.b 1,0,0,1,0,0,1,1,0 ;   43    ($)
  Data.b 1,1,1,0,1,1,0,1,0 ;   44    (%)
  Data.b 1,1,1,0,1,0,1,1,0 ;   45    (/)
  Data.b 1,0,0,1,1,0,0,1,0 ;   46    (+)
  Data.b 1,0,1,0,1,1,1,1,0 ;   47 *Start/Stop
  print_barcode_code93_end:
  
  print_barcode_code93a:
  Data.b  44,30 ;  0
  Data.b  43,10 ;  1
  Data.b  43,11 ;  2
  Data.b  43,12 ;  3
  Data.b  43,13 ;  4
  Data.b  43,14 ;  5
  Data.b  43,15 ;  6
  Data.b  43,16 ;  7
  Data.b  43,17 ;  8
  Data.b  43,18 ;  9
  Data.b  43,19 ; 10
  Data.b  43,20 ; 11
  Data.b  43,21 ; 12
  Data.b  43,22 ; 13
  Data.b  43,23 ; 14
  Data.b  43,24 ; 15
  Data.b  43,25 ; 16
  Data.b  43,26 ; 17
  Data.b  43,27 ; 18
  Data.b  43,28 ; 19
  Data.b  43,29 ; 20
  Data.b  43,30 ; 21
  Data.b  43,31 ; 22
  Data.b  43,32 ; 23
  Data.b  43,33 ; 24
  Data.b  43,34 ; 25
  Data.b  43,35 ; 26
  Data.b  44,10 ; 27
  Data.b  44,11 ; 28
  Data.b  44,12 ; 29
  Data.b  44,13 ; 30
  Data.b  44,14 ; 31
  Data.b  00,38 ; 32
  Data.b  45,10 ; 33
  Data.b  45,11 ; 34
  Data.b  45,12 ; 35
  Data.b  00,39 ; 36
  Data.b  00,42 ; 37
  Data.b  45,15 ; 38
  Data.b  45,16 ; 39
  Data.b  45,17 ; 40
  Data.b  45,18 ; 41
  Data.b  45,19 ; 42
  Data.b  00,41 ; 43
  Data.b  45,21 ; 44
  Data.b  00,36 ; 45
  Data.b  00,37 ; 46
  Data.b  00,40 ; 47
  Data.b  00, 0 ; 48
  Data.b  00, 1 ; 49
  Data.b  00, 2 ; 50
  Data.b  00, 3 ; 51
  Data.b  00, 4 ; 52
  Data.b  00, 5 ; 53
  Data.b  00, 6 ; 54
  Data.b  00, 7 ; 55
  Data.b  00, 8 ; 56
  Data.b  00, 9 ; 57
  Data.b  45,35 ; 58
  Data.b  44,15 ; 59
  Data.b  44,16 ; 60
  Data.b  44,17 ; 61
  Data.b  44,18 ; 62
  Data.b  44,19 ; 63
  Data.b  44,31 ; 64
  Data.b  00,10 ; 65
  Data.b  00,11 ; 66
  Data.b  00,12 ; 67
  Data.b  00,13 ; 68
  Data.b  00,14 ; 69
  Data.b  00,15 ; 70
  Data.b  00,16 ; 71
  Data.b  00,17 ; 72
  Data.b  00,18 ; 73
  Data.b  00,19 ; 74
  Data.b  00,20 ; 75
  Data.b  00,21 ; 76
  Data.b  00,22 ; 77
  Data.b  00,23 ; 78
  Data.b  00,24 ; 79
  Data.b  00,25 ; 80
  Data.b  00,26 ; 81
  Data.b  00,27 ; 82
  Data.b  00,28 ; 83
  Data.b  00,29 ; 84
  Data.b  00,30 ; 85
  Data.b  00,31 ; 86
  Data.b  00,32 ; 87
  Data.b  00,33 ; 88
  Data.b  00,34 ; 89
  Data.b  00,35 ; 90
  Data.b  44,20 ; 91
  Data.b  44,21 ; 92
  Data.b  44,22 ; 93
  Data.b  44,23 ; 94
  Data.b  44,24 ; 95
  Data.b  44,32 ; 96
  Data.b  46,10 ; 97
  Data.b  46,11 ; 98
  Data.b  46,12 ; 99
  Data.b  46,13 ;100
  Data.b  46,14 ;101
  Data.b  46,15 ;102
  Data.b  46,16 ;103
  Data.b  46,17 ;104
  Data.b  46,18 ;105
  Data.b  46,19 ;106
  Data.b  46,20 ;107
  Data.b  46,21 ;108
  Data.b  46,22 ;109
  Data.b  46,23 ;110
  Data.b  46,24 ;111
  Data.b  46,25 ;112
  Data.b  46,26 ;113
  Data.b  46,27 ;114
  Data.b  46,28 ;115
  Data.b  46,29 ;116
  Data.b  46,30 ;117
  Data.b  46,31 ;118
  Data.b  46,32 ;119
  Data.b  46,33 ;120
  Data.b  46,34 ;121
  Data.b  46,35 ;122
  Data.b  44,25 ;123
  Data.b  44,26 ;124
  Data.b  44,27 ;125
  Data.b  44,28 ;126
  Data.b  44,29 ;127
  print_barcode_code93a_end:
  
  print_barcode_code2of5:
  Data.b 0,0,1,1,0 ; 0 NNWWN
  Data.b 1,0,0,0,1 ; 1 WNNNW
  Data.b 0,1,0,0,1 ; 2 NWNNW
  Data.b 1,1,0,0,0 ; 3 WWNNN
  Data.b 0,0,1,0,1 ; 4 NNWNW
  Data.b 1,0,1,0,0 ; 5 WNWNN
  Data.b 0,1,1,0,0 ; 6 NWWNN
  Data.b 0,0,0,1,1 ; 7 NNNWW
  Data.b 1,0,0,1,0 ; 8 WNNWN
  Data.b 0,1,0,1,0 ; 9 NWNWN
  print_barcode_code2of5_end:
  
  print_barcode_2digit_supp:
  Data.b 1,1 ; 0
  Data.b 1,0 ; 1
  Data.b 0,1 ; 2
  Data.b 0,0 ; 3
  print_barcode_2digit_supp_end:
  
  print_barcode_5digit_supp:
  Data.b 0,0,1,1,1 ; 0
  Data.b 0,1,0,1,1 ; 1
  Data.b 0,1,1,0,1 ; 2
  Data.b 0,1,1,1,0 ; 3
  Data.b 1,0,0,1,1 ; 4
  Data.b 1,1,0,0,1 ; 5
  Data.b 1,1,1,0,0 ; 6
  Data.b 1,0,1,0,1 ; 7
  Data.b 1,0,1,1,0 ; 8
  Data.b 1,1,0,1,0 ; 9
  print_barcode_5digit_supp_end:
  
  print_barcode_codabar:
  Data.b 0,0,0,0,0,1,1 ; 0
  Data.b 0,0,0,0,1,1,0 ; 1
  Data.b 0,0,0,1,0,0,1 ; 2
  Data.b 1,1,0,0,0,0,0 ; 3
  Data.b 0,0,1,0,0,1,0 ; 4
  Data.b 1,0,0,0,0,1,0 ; 5 wrong example that encoded digit 5 as "101101001" correct is "110101001"
  Data.b 0,1,0,0,0,0,1 ; 6
  Data.b 0,1,0,0,1,0,0 ; 7
  Data.b 0,1,1,0,0,0,0 ; 8
  Data.b 1,0,0,1,0,0,0 ; 9
  Data.b 0,0,0,1,1,0,0 ; -
  Data.b 0,0,1,1,0,0,0 ; $
  Data.b 1,0,0,0,1,0,1 ; :
  Data.b 1,0,1,0,0,0,1 ; /
  Data.b 1,0,1,0,1,0,0 ; .
  Data.b 0,0,1,0,1,0,1 ; + corrected wrong encoding : "0011111"
  Data.b 0,0,1,1,0,1,0 ; A
  Data.b 0,1,0,1,0,0,1 ; B corrected wrong encoding : "0001011"
  Data.b 0,0,0,1,0,1,1 ; C corrected wrong encoding : "0101001"
  Data.b 0,0,0,1,1,1,0 ; D
  print_barcode_codabar_end:
EndDataSection

CompilerIf Defined(PurePDF_Include,#PB_Constant)
  Procedure.f pdf_Barcode_EAN8(x.f, y.f, barcode.s, h.f, w.f,align.l,offsety.f, edgebar.f, checkdigit.l)
    ProcedureReturn ipf_Barcode_EAN8(x,y,barcode,h,w,align,offsety,edgebar,checkdigit)
  EndProcedure
  
  Procedure.f pdf_Barcode_EAN13(x.f, y.f, barcode.s, h.f, w.f,align.l,offsety.f, edgebar.f, checkdigit.l)
    ProcedureReturn ipf_Barcode_EAN13(x,y,barcode,h,w,align,offsety,edgebar,checkdigit)
  EndProcedure
  
  Procedure.f pdf_Barcode_UPC_A(x.f, y.f, barcode.s, h.f, w.f,align.l,offsety.f, edgebar.f, checkdigit.l)
    ProcedureReturn ipf_Barcode_UPC_A(x,y,barcode,h,w,align,offsety,edgebar,checkdigit)
  EndProcedure
  
  Procedure.f pdf_Barcode_UPC_E(x.f, y.f, barcode.s, h.f, w.f,align.l,offsety.f, edgebar.f, nsys.l)
    ProcedureReturn ipf_Barcode_UPC_E(x,y,barcode,h,w,align,offsety,edgebar,nsys)
  EndProcedure
  
  Procedure.f pdf_Barcode_Code128(x.f,y.f,barcode.s,h.f,w.f,align.l,offsetx.f,offsety.f,start.l)
    ProcedureReturn ipf_BarCode_Code128(x,y,barcode,h,w,align,offsetx,offsety,start)
  EndProcedure
  
  Procedure.f pdf_Barcode_Code39(x.f,y.f,barcode.s,h.f,w.f,align.l,offsetx.f,offsety.f,checkdigit.l)
    ProcedureReturn ipf_BarCode_Code39(x,y,barcode,h,w,align,offsetx,offsety,checkdigit)
  EndProcedure
  
  Procedure.f pdf_Barcode_Code39Full(x.f,y.f,barcode.s,h.f,w.f,align.l,offsetx.f,offsety.f,checkdigit.l)
    ProcedureReturn ipf_BarCode_Code39Full(x,y,barcode,h,w,align,offsetx,offsety,checkdigit)
  EndProcedure
  
  Procedure.f pdf_Barcode_Code93(x.f,y.f,barcode.s,h.f,w.f,align.l,offsetx.f,offsety.f)
    ProcedureReturn ipf_BarCode_Code93(x,y,barcode,h,w,align,offsetx,offsety)
  EndProcedure
  
  Procedure.f pdf_Barcode_Code2of5std(x.f,y.f,barcode.s,h.f,w.f,align.l,offsetx.f,offsety.f,checkdigit.l)
    ProcedureReturn ipf_Barcode_Code2of5std(x,y,barcode,h,w,align,offsetx,offsety,checkdigit)
  EndProcedure
  
  Procedure.f pdf_Barcode_Code2of5(x.f,y.f,barcode.s,h.f,w.f,align.l,offsetx.f,offsety.f,checkdigit.l)
    ProcedureReturn ipf_Barcode_Code2of5(x,y,barcode,h,w,align,offsetx,offsety,checkdigit)
  EndProcedure
  
  Procedure.f pdf_Barcode_2Digit_Supp(x.f,y.f,barcode.s,h.f,w.f,align.l,offsetx.f,offsety.f)
    ProcedureReturn ipf_Barcode_2Digit_Supp(x,y,barcode,h,w,align,offsetx,offsety)
  EndProcedure
  
  Procedure.f pdf_Barcode_5Digit_Supp(x.f,y.f,barcode.s,h.f,w.f,align.l,offsetx.f,offsety.f)
    ProcedureReturn ipf_Barcode_5Digit_Supp(x,y,barcode,h,w,align,offsetx,offsety)
  EndProcedure
  
  Procedure.f pdf_Barcode_Codabar(x.f,y.f,barcode.s,h.f,w.f,align.l,offsetx.f,offsety.f)
    ProcedureReturn ipf_Barcode_Codabar(x,y,barcode,h,w,align,offsetx,offsety)
  EndProcedure
CompilerElse
  ProcedureDLL pdf_Barcode_EAN8(x.f, y.f, barcode.s, h.f, w.f,align.l,offsety.f, edgebar.f, checkdigit.l)
    ProcedureReturn ipf_Barcode_EAN8(x,y,barcode,h,w,align,offsety,edgebar,checkdigit)
  EndProcedure
  
  ProcedureDLL pdf_Barcode_EAN13(x.f, y.f, barcode.s, h.f, w.f,align.l,offsety.f, edgebar.f, checkdigit.l)
    ProcedureReturn ipf_Barcode_EAN13(x,y,barcode,h,w,align,offsety,edgebar,checkdigit)
  EndProcedure
  
  ProcedureDLL pdf_Barcode_UPC_A(x.f, y.f, barcode.s, h.f, w.f,align.l,offsety.f, edgebar.f, checkdigit.l)
    ProcedureReturn ipf_Barcode_UPC_A(x,y,barcode,h,w,align,offsety,edgebar,checkdigit)
  EndProcedure
  
  ProcedureDLL pdf_Barcode_UPC_E(x.f, y.f, barcode.s, h.f, w.f,align.l,offsety.f, edgebar.f, nsys.l)
    ProcedureReturn ipf_Barcode_UPC_E(x,y,barcode,h,w,align,offsety,edgebar,nsys)
  EndProcedure
  
  ProcedureDLL pdf_Barcode_Code128(x.f,y.f,barcode.s,h.f,w.f,align.l,offsetx.f,offsety.f,start.l)
    ProcedureReturn ipf_BarCode_Code128(x,y,barcode,h,w,align,offsetx,offsety,start)
  EndProcedure
  
  ProcedureDLL pdf_Barcode_Code39(x.f,y.f,barcode.s,h.f,w.f,align.l,offsetx.f,offsety.f,checkdigit.l)
    ProcedureReturn ipf_BarCode_Code39(x,y,barcode,h,w,align,offsetx,offsety,checkdigit)
  EndProcedure
  
  ProcedureDLL pdf_Barcode_Code39Full(x.f,y.f,barcode.s,h.f,w.f,align.l,offsetx.f,offsety.f,checkdigit.l)
    ProcedureReturn ipf_BarCode_Code39Full(x,y,barcode,h,w,align,offsetx,offsety,checkdigit)
  EndProcedure
  
  ProcedureDLL pdf_Barcode_Code93(x.f,y.f,barcode.s,h.f,w.f,align.l,offsetx.f,offsety.f)
    ProcedureReturn ipf_BarCode_Code93(x,y,barcode,h,w,align,offsetx,offsety)
  EndProcedure
  
  ProcedureDLL pdf_Barcode_Code2of5std(x.f,y.f,barcode.s,h.f,w.f,align.l,offsetx.f,offsety.f,checkdigit.l)
    ProcedureReturn ipf_Barcode_Code2of5std(x,y,barcode,h,w,align,offsetx,offsety,checkdigit)
  EndProcedure
  
  ProcedureDLL pdf_Barcode_Code2of5(x.f,y.f,barcode.s,h.f,w.f,align.l,offsetx.f,offsety.f,checkdigit.l)
    ProcedureReturn ipf_Barcode_Code2of5(x,y,barcode,h,w,align,offsetx,offsety,checkdigit)
  EndProcedure
  
  ProcedureDLL pdf_Barcode_2Digit_Supp(x.f,y.f,barcode.s,h.f,w.f,align.l,offsetx.f,offsety.f)
    ProcedureReturn ipf_Barcode_2Digit_Supp(x,y,barcode,h,w,align,offsetx,offsety)
  EndProcedure
  
  ProcedureDLL pdf_Barcode_5Digit_Supp(x.f,y.f,barcode.s,h.f,w.f,align.l,offsetx.f,offsety.f)
    ProcedureReturn ipf_Barcode_5Digit_Supp(x,y,barcode,h,w,align,offsetx,offsety)
  EndProcedure
  
  ProcedureDLL pdf_Barcode_Codabar(x.f,y.f,barcode.s,h.f,w.f,align.l,offsetx.f,offsety.f)
    ProcedureReturn ipf_Barcode_Codabar(x,y,barcode,h,w,align,offsetx,offsety)
  EndProcedure
CompilerEndIf
; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 2102
; FirstLine = 2089
; Folding = ------------